#include <iostream> 
#include <windows.h> 
#include <process.h>
//http://blog.naver.com/cmw1728?Redirect=Log&logNo=220478001188
//http://blog.naver.com/popssong?Redirect=Log&logNo=220360094062

#define BUFSIZE 100 
#define NAMESIZE 20 

DWORD WINAPI SendMSG(void *arg);
DWORD WINAPI RecvMSG(void *arg);

void ErrorHandling(char *message);
char name[NAMESIZE]="[Default]";
char message[BUFSIZE];

int main(int argc, char **argv) 
{
    WSADATA wsaData;
    SOCKET sock;
    SOCKADDR_IN servAddr;
    HANDLE hThread1, hThread2;
    DWORD dwThreadID1, dwThreadID2;
    if(argc!=4) 
    {
        printf("Usage : %s \n", argv[0]);
        exit(1);
    }

    if(WSAStartup(MAKEWORD(2, 2), &wsaData) != 0)/* Load Winsock 2.2 DLL */
    {
        ErrorHandling("WSAStartup() error!");
    }

    sprintf(name, "[%s]", argv[3]);

    sock = socket(PF_INET, SOCK_STREAM, 0);
    if(sock == INVALID_SOCKET) 
    {
        ErrorHandling("socket() error");
    }
    
    memset(&servAddr, 0, sizeof(servAddr));
    servAddr.sin_family     = AF_INET;
    servAddr.sin_addr.s_addr= inet_addr(argv[1]);
    servAddr.sin_port       = htons(atoi(argv[2]));

    if(connect(sock, (SOCKADDR*)&servAddr, sizeof(servAddr))==SOCKET_ERROR)
    {
        ErrorHandling("connect() error");
    }

#if 0 
    _CRTIMP uintptr_t __cdecl _beginthreadex( void *_Security, unsigned _StackSize, unsigned (__stdcall *_StartAddress) (void *), void *_ArgList, unsigned _InitFlag, unsigned *_ThrdAddr );
#endif 

    hThread1 = (HANDLE)_beginthreadex(NULL, 0, (unsigned (__stdcall *) (void *))SendMSG, (void*)sock, 0, (unsigned *)&dwThreadID1);
    hThread2 = (HANDLE)_beginthreadex(NULL, 0, (unsigned (__stdcall *) (void *))RecvMSG, (void*)sock, 0, (unsigned *)&dwThreadID2);
    if(hThread1==0 || hThread2==0) 
    {
        ErrorHandling("  ");
    }
    WaitForSingleObject(hThread1, INFINITE);
    WaitForSingleObject(hThread2, INFINITE);
    closesocket(sock);
    return 0;
}

DWORD WINAPI SendMSG(void *arg) // ޽    Լ
{
    SOCKET sock = (SOCKET)arg;
    char nameMessage[NAMESIZE+BUFSIZE];
    while(1) 
    {
        fgets(message, BUFSIZE, stdin);
        sprintf(nameMessage,"%s %s", name, message);
        if(!strcmp(message, "q\n")) // 'q' Է½ 
        {
            closesocket(sock);
            exit(0);
        }
        send(sock, nameMessage, strlen(nameMessage), 0);
    }
}

DWORD WINAPI RecvMSG(void *arg) /* ޽    Լ */
{
    SOCKET sock = (SOCKET)arg;
    char nameMessage[NAMESIZE+BUFSIZE];
    int strLen;
    while(1) 
    {
        strLen = recv(sock, nameMessage, NAMESIZE+BUFSIZE-1, 0);

        if(strLen==-1)
        {
            return 1;
        }

        nameMessage[strLen]=0;
        fputs(nameMessage, stdout);
    }
}

void ErrorHandling(char *message) 
{
    fputs(message, stderr);
    fputc('\n', stderr);
    exit(1);
}

